Package de.gebit.integrity.remoting.client

## Interface IntegrityRemotingClientListener

-     public interface IntegrityRemotingClientListener

  This listener must be implemented by anyone wanting to attach to the remoting client.
  Author:
    Rene Schneider - initial API and implementation

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `onAbortExecution​(String anAbortExecutionMessage, String anAbortExecutionStackTrace)` | Called when the server has hit an AbortExecutionException aborting further test execution.
    `void` | `onBaselineReceived​(SetList aSetList, Endpoint anEndpoint)` | Called after the initial set list baseline was received from the server.
    `void` | `onConfirmCreateBreakpoint​(Integer anEntryReference, Endpoint anEndpoint)` | Called when the server confirms the creation of a breakpoint.
    `void` | `onConfirmRemoveBreakpoint​(Integer anEntryReference, Endpoint anEndpoint)` | Called when the server confirms the removal of a breakpoint.
    `void` | `onConnectionLost​(Endpoint anEndpoint)` | Called if the connection was lost.
    `void` | `onConnectionSuccessful​(IntegrityRemotingVersionMessage aRemoteVersion, Endpoint anEndpoint)` | Called if a connection to a server was established successfully.
    `void` | `onExecutionStateUpdate​(ExecutionStates aState, Endpoint anEndpoint)` | Called when the execution state has changed.
    `void` | `onForkResultSummaryRetrieval​(Integer aSuccessCount, Integer aFailureCount, Integer aTestExceptionCount, Integer aCallExceptionCount)` | Called when a fork has finished an execution block and has returned the summary result data.
    `void` | `onSetListUpdate​(SetListEntry[] someUpdatedEntries, Integer anEntryInExecution, Endpoint anEndpoint)` | Called when there are updates to the set list.
    `void` | `onTestRunnerCallbackMessageRetrieval​(String aCallbackClassName, TestRunnerCallbackMethods aMethod, Serializable[] someData)` | Called when data for a test runner callback was received from a fork.
    `void` | `onTimeSyncRequest​(Date aStartDate, List<org.eclipse.xtext.util.Pair<Long,​TemporalUnit>> aDiffTime, BigDecimal aProgressionFactor, String[] someTargetedForks)` | Called when a timesync command has arrived.
    `void` | `onTimeSyncResponse​(TimeSyncResultMessage aResult)` | Called when a timesync response has arrived.
    `void` | `onVariableUnsetRetrieval​(String aVariableName)` | Called when an unsetting of a variable was received from a fork.
    `void` | `onVariableUpdateRetrieval​(String aVariableName, Serializable aValue)` | Called when an update for a variable was received from a fork.
    `void` | `onVersionMismatch​(IntegrityRemotingVersionMessage aRemoteVersion, Endpoint anEndpoint)` | Called on a connection attempt if the remote version doesn't match the local version.

- - ### Method Detail

    - #### onConnectionSuccessful

          void onConnectionSuccessful​(IntegrityRemotingVersionMessage aRemoteVersion,
                                      Endpoint anEndpoint)

      Called if a connection to a server was established successfully.
      Parameters:
        `aRemoteVersion` - the version of the server
        `anEndpoint` - the endpoint

    - #### onConnectionLost

          void onConnectionLost​(Endpoint anEndpoint)

      Called if the connection was lost.
      Parameters:
        `anEndpoint` - the endpoint

    - #### onBaselineReceived

          void onBaselineReceived​(SetList aSetList,
                                  Endpoint anEndpoint)

      Called after the initial set list baseline was received from the server. The server will send this baseline right after connecting.
      Parameters:
        `aSetList` - the set list
        `anEndpoint` - the endpoint

    - #### onExecutionStateUpdate

          void onExecutionStateUpdate​(ExecutionStates aState,
                                      Endpoint anEndpoint)

      Called when the execution state has changed.
      Parameters:
        `aState` - the new state
        `anEndpoint` - the endpoint

    - #### onVersionMismatch

          void onVersionMismatch​(IntegrityRemotingVersionMessage aRemoteVersion,
                                 Endpoint anEndpoint)

      Called on a connection attempt if the remote version doesn't match the local version.
      Parameters:
        `aRemoteVersion` - the remote version information
        `anEndpoint` - the endpoint

    - #### onSetListUpdate

          void onSetListUpdate​(SetListEntry[] someUpdatedEntries,
                               Integer anEntryInExecution,
                               Endpoint anEndpoint)

      Called when there are updates to the set list.
      Parameters:
        `someUpdatedEntries` - the updated entries
        `anEntryInExecution` - the currently executed entry (may be null in case there's no change)
        `anEndpoint` - the endpoint

    - #### onConfirmCreateBreakpoint

          void onConfirmCreateBreakpoint​(Integer anEntryReference,
                                         Endpoint anEndpoint)

      Called when the server confirms the creation of a breakpoint.
      Parameters:
        `anEntryReference` - the entry at which the breakpoint was created
        `anEndpoint` - the endpoint

    - #### onConfirmRemoveBreakpoint

          void onConfirmRemoveBreakpoint​(Integer anEntryReference,
                                         Endpoint anEndpoint)

      Called when the server confirms the removal of a breakpoint.
      Parameters:
        `anEntryReference` - the entry at which the breakpoint was removed
        `anEndpoint` - the endpoint

    - #### onTestRunnerCallbackMessageRetrieval

          void onTestRunnerCallbackMessageRetrieval​(String aCallbackClassName,
                                                    TestRunnerCallbackMethods aMethod,
                                                    Serializable[] someData)

      Called when data for a test runner callback was received from a fork.
      Parameters:
        `aCallbackClassName` - the callback classes' name
        `aMethod` - the method
        `someData` - the payload

    - #### onVariableUpdateRetrieval

          void onVariableUpdateRetrieval​(String aVariableName,
                                         Serializable aValue)

      Called when an update for a variable was received from a fork.
      Parameters:
        `aVariableName` - the name of the variable
        `aValue` - the new value

    - #### onVariableUnsetRetrieval

          void onVariableUnsetRetrieval​(String aVariableName)

      Called when an unsetting of a variable was received from a fork.
      Parameters:
        `aVariableName` - the name of the variable

    - #### onTimeSyncRequest

          void onTimeSyncRequest​(Date aStartDate,
                                 List<org.eclipse.xtext.util.Pair<Long,​TemporalUnit>> aDiffTime,
                                 BigDecimal aProgressionFactor,
                                 String[] someTargetedForks)

      Called when a timesync command has arrived.
      Parameters:
        `aStartDate` - the start date
        `aDiffTime` - the relative time modification
        `aProgressionFactor` - the progression factor
        `someTargetedForks` - the forks that this message should be sent to

    - #### onTimeSyncResponse

          void onTimeSyncResponse​(TimeSyncResultMessage aResult)

      Called when a timesync response has arrived. If the arguments' error fields are null, this was successful.
      Parameters:
        `anErrorMessage` -
        `anErrorStackTrace` -

    - #### onAbortExecution

          void onAbortExecution​(String anAbortExecutionMessage,
                                String anAbortExecutionStackTrace)

      Called when the server has hit an AbortExecutionException aborting further test execution.
      Parameters:
        `anAbortExecutionMessage` - The message of the AbortExecutionException
        `anAbortExecutionStackTrace` - The stacktrace of the AbortExecutionException

    - #### onForkResultSummaryRetrieval

          void onForkResultSummaryRetrieval​(Integer aSuccessCount,
                                            Integer aFailureCount,
                                            Integer aTestExceptionCount,
                                            Integer aCallExceptionCount)

      Called when a fork has finished an execution block and has returned the summary result data.
      Parameters:
        `aSuccessCount` -
        `aFailureCount` -
        `aTestExceptionCount` -
        `aCallExceptionCount` -